package ac.essex.gp.apps;

import javax.swing.*;
import java.awt.*;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.StringTokenizer;
import java.util.Vector;
import java.io.StringBufferInputStream;
import java.io.Reader;
import java.io.InputStream;

/**
 * Created by IntelliJ IDEA.
 * User: ooechs
 * Date: 02-Dec-2008
 * Time: 09:53:45
 * To change this template use File | Settings | File Templates.
 */
public class Gunther extends JFrame {

    JTextArea input, output;
    JEditorPane preview;

    public static void main(String[] args) {
        new Gunther();
    }

    public Gunther() {

        super("Gunther");

        Container c = getContentPane();
        JPanel p = new JPanel(new GridLayout(2, 1));
        input = new JTextArea();
        output = new JTextArea();
        preview = new JEditorPane();
        preview.setEditable( false );
        preview.setContentType("text/html");

        p.add(new JScrollPane(input));
        p.add(new JScrollPane(output));
        c.add(p);
        JButton process = new JButton("Process");
        process.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String t = process(input.getText());
                output.setText(t);
                preview.setText(t);
            }
        });

        JDialog f = new JDialog(this);
        f.setTitle("Preview");
        f.getContentPane().add(new JScrollPane(preview));
        f.setSize(540, 480);
        f.setLocation(640, 0);
        f.setVisible(true);

        c.add(process, BorderLayout.SOUTH);
        setSize(640, 480);
        setVisible(true);

    }

    public String process(String text) {
        StringBuffer out = new StringBuffer(1000);
        out.append("<html><table>");
        Vector<String> items = new Vector<String>();
        // parse into lines
        String month = null;
        StringTokenizer st = new StringTokenizer(text, System.getProperty("line.separator"));
        while (st.hasMoreTokens()) {
            String line = st.nextToken();
            int colonPos = line.indexOf(":");

            String rest = null;
            if (colonPos > -1) {

                if (month == null) {
                    month = "?";
                }

                if (items.size() > 0) {
                    out.append("<tr>");
                    out.append("<th valign=top>");
                    out.append(month.trim());
                    out.append("</th>");
                    out.append("<td>");
                    for (int i = 0; i < items.size(); i++) {
                        String s = items.elementAt(i);
                        out.append(s.trim());
                        out.append("<br />\n");
                    }
                    out.append("</td>");
                    out.append("</tr>\n");
                }

                month = line.substring(0, colonPos);
                rest = line.substring(colonPos + 1);

                items.clear();
                items.add(rest);
            } else {
                rest = line;
                items.add(line);
            }

        }

                if (month == null) {
                    month = "?";
                }
                if (items.size() > 0) {
                    out.append("<tr>");
                    out.append("<th valign=top>");
                    out.append(month.trim());
                    out.append("</th>");
                    out.append("<td>");
                    for (int i = 0; i < items.size(); i++) {
                        String s = items.elementAt(i);
                        out.append(s.trim());
                        out.append("<br />\n");
                    }
                    out.append("</td>");
                    out.append("</tr>\n");
                }

        out.append("</table></html>");
        return out.toString();
    }

   


}
