package ac.essex.gp.apps;

import java.util.Arrays;
import java.util.Collections;
import java.util.Vector;

/**
 * <p>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 12-Dec-2008
 * @version 1.0
 */
public class SpeedTest {

    public static void main(String[] args) {

        long start = System.currentTimeMillis();

        for (int n = 0; n < 50; n++) {
            String[] array = new String[500];
            for (int i = 0; i < 500; i++) {
                array[i] = "hello world";
            }
            Arrays.sort(array);
        }

        long end = System.currentTimeMillis();

        System.out.println("Time: " + (end - start));

        start = System.currentTimeMillis();

        for (int n = 0; n < 50; n++) {
            Vector<String> v = new Vector<String>(500);
            for (int i = 0; i < 500; i++) {
                v.add("hello world");
            }
            Collections.sort(v);
        }

        end = System.currentTimeMillis();

        System.out.println("Time: " + (end - start));

    }


}
